/*
 
 todo: set quantities
 todo: tie widget quntities to game variables
 todo: set up timeline
 todo: set up dynamics
 todo: set up dialogs
 todo: release resources?
 todo: allow events to, like, end the game, or whatever
 todo: playsample doesn't seem to work:/
 todo: when pop bars move left, blood spatter
 todo: as population decreases, blot out parts of the city
 todo: as population increases, add new bits in(i guess)
 
 todo: ALLOW INGAME RESTART
 */

#include <allegro.h>
#include <iostream>
#include <vector>
#include <list>
#include <stack>
#include <algorithm>
#include "boost/foreach.hpp"
#include <boost/lexical_cast.hpp>
#include <ApplicationServices/ApplicationServices.h>

using namespace std;

#define foreach BOOST_FOREACH

typedef double num;

BITMAP* buffer;
BITMAP* tilemap;

#include "sound.hpp"
#include "misc.hpp"
#include "timer.hpp"
#include "printwrap.hpp"

unsigned int kills=0;
unsigned int empire=0;
unsigned int maxempire=0;

void drawtile(int destx,int desty, int tilen);
void mdrawtile(int destx,int desty, int tilen);
bool noenemyat(int x, int y);
void delenemyat(int x, int y);
void delwallat(int x, int y);
int wallindex(int x, int y);
void newwall(int x, int y);
bool canplayermove(int x, int y);

vector<pair<int,int> > flagdelete;
vector<pair<int,int> > flagdelete2;

const int ts=13;
char *statustext="";
bool warover=false;
bool quit=false;
bool leave=false;
int titletimer=0;
bool finishedtitle;
bool dead;
bool deathbymurder;


const int screenwidth=160;
const int screenheight=120;
const int tilesize=7;
const int xtiles=screenwidth/tilesize;
const int ytiles=screenheight/tilesize;
const int xmarginl=(screenwidth-xtiles*tilesize)/2;
const int xmarginr=screenwidth-(screenheight-xtiles*tilesize)/2;
const int ymargint=(screenheight-ytiles*tilesize)/2;
const int ymarginb=screenheight-(screenheight-ytiles*tilesize)/2;
const int tilemapwidth=20;

#define tilenum(tx, ty)  (tx+tilemapwidth*ty)


const int tile_rock=tilenum(0,11);
const int tile_tree=tilenum(1,11);
const int tile_grass=tilenum(11, 0);
const int tile_blood=tilenum(4,0);
const int tile_blood1=tilenum(10,0);
const int tile_blood2=tilenum(10,1);
const int tile_blood3=tilenum(10,2);

int tiles[xtiles][ytiles];
bool playermove[xtiles][ytiles];
bool enemymove[xtiles][ytiles];
bool obstacles[xtiles][ytiles];
float scent[xtiles][ytiles];
float perfume[xtiles][ytiles];


enum EntityType {et_player};
class Entity
	{
	public:
		int x;
		int y;
		int basetile;
		int dir;
		bool aggressive;
		void follow_smell();
		virtual void move(){};
		virtual void draw(){};
		virtual ~Entity(){};
		Entity(){};
	};

Entity* enemyat(int x, int y);

class Player: public Entity
	{
	public:	
		virtual void draw()
		{
			mdrawtile(x, y, tilenum(dir,10));
		}
	};

class Peasant: public Entity
	{
	public:
		virtual void move()
		{
			follow_smell();
		};
		Peasant()
		{
			aggressive=false;
			dir=rand()%4;
			basetile=tilenum(0,1);
		}
	};

class Swordsman: public Entity
	{
	public:
		virtual void move()
		{
			if (canplayermove(x-1, y))
			{
				flagdelete2.push_back(pair<int,int>(x-1,y));
				return;
			}
			if (canplayermove(x+1, y))
			{
				flagdelete2.push_back(pair<int,int>(x+1,y));
				return;
			}
			if (canplayermove(x, y+1))
			{
				flagdelete2.push_back(pair<int,int>(x,y+1));				
				return;
			}
			if (canplayermove(x, y-1))
			{
				flagdelete2.push_back(pair<int,int>(x,y-1));
				return;
			}
		blah:
			follow_smell();
		};
		Swordsman()
		{
			aggressive=false;
			dir=rand()%4;
			basetile=tilenum(0,0);
		}
	};

class BloodWall
	{
	public:
		int x;
		int y;
		int walltype;
		bool activearm[4];		
		virtual void process(){};
		virtual ~BloodWall(){};
		virtual void draw(){};
	};

const int forkarmup=tilenum(8,1);
const int forkarmdown=tilenum(8,3);
const int forkarmleft=tilenum(7,2);
const int forkarmright=tilenum(9,2);

bool internalwall(int x,int y)
{
	return (canplayermove(x+1,y) &&canplayermove(x-1,y) &&canplayermove(x,y+1) &&canplayermove(x,y-1)&& (x>0) && (x<xtiles-1)&&(y>0)&&(y<ytiles-1));
}

bool checksurroundedsurrounded(int x, int y)
{
	bool r=false;
	if (internalwall(x+1,y))
	{
		flagdelete.push_back(pair<int,int>(x+1,y));
		r=true;
	}
	if (internalwall(x,y+1))
	{
		flagdelete.push_back(pair<int,int>(x,y+1));
		r=true;
	}
	if (internalwall(x-1,y))
	{
		flagdelete.push_back(pair<int,int>(x-1,y));
		r=true;
	}
	if (internalwall(x,y-1))
	{
		flagdelete.push_back(pair<int,int>(x,y-1));
		r=true;
	}
	return r;
}

class Fork: public BloodWall
	{
	public:
		Fork()
		{
			for (int i=0;i<4;i++)
				activearm[i]=0;
		}
		
		bool checksurrounded()
		{
			if (internalwall(x,y))
			{
				flagdelete.push_back(pair<int,int>(x,y));
			}
			return false;
		}
		void process()
		{
			if (activearm[0])
			{
				activearm[0]=false;
				newwall(x,y-1);
				if (checksurroundedsurrounded(x,y-1))
					return;
			}
			if (activearm[1])
			{
				activearm[1]=false;
				newwall(x,y+1);
				if (checksurroundedsurrounded(x,y+1))
					return;
			}
			if (activearm[2])
			{
				activearm[2]=false;
				newwall(x-1,y);
				if (checksurroundedsurrounded(x-1,y))
					return;
			}
			if (activearm[3])
			{
				activearm[3]=false;
				newwall(x+1,y);
				if (checksurroundedsurrounded(x+1,y))
					return;
			}
			
			Entity* e;
			e=enemyat(x,y-1);
			if (e)
			{
				tiles[x][y-1]=e->basetile+e->dir;
				activearm[0]=true;
				delenemyat(x,y-1);
			}
			
			e=enemyat(x,y+1);
			if (e)
			{			
				tiles[x][y+1]=e->basetile+e->dir;
				activearm[1]=true;
				delenemyat(x,y+1);
				
			}
			
				e=enemyat(x-1,y);
				if (e)
			{
				tiles[x-1][y]=e->basetile+e->dir;
				activearm[2]=true;
				delenemyat(x-1,y);
			}
			
				e=enemyat(x+1,y);
				if (e)
			{
				tiles[x+1][y]=e->basetile+e->dir;
				activearm[3]=true;
				delenemyat(x+1,y);
			}
			
		};
		void draw()
		{
			drawtile(x,y,tilenum(5,2));
			if (activearm[0])
				mdrawtile(x, y-1, forkarmup);
			if (activearm[1])
				mdrawtile(x, y+1, forkarmdown);
			if (activearm[2])
				mdrawtile(x-1, y, forkarmleft);
			if (activearm[3])
				mdrawtile(x+1, y, forkarmright);
		};
	};

Player* player=0;

vector<Entity*> enemies;
vector<BloodWall*> walls;

void newwall(int x, int y)
{
	if (tiles[x][y]<tilemapwidth)
	{
		tiles[x][y]=tilenum(10,0);
	}
	else if (tiles[x][y]<tilemapwidth*2)
	{
		tiles[x][y]=tilenum(10,1);
	}
	else
	{
		tiles[x][y]=tilenum(10,2);
	}
}

float frand01()
{	
	return (float)rand()/(float)RAND_MAX;
}

void Entity::follow_smell()
{
	float curmax=scent[x][y];
	int tarx=x;
	int tary=y;
	
	if (x>0 && !obstacles[x-1][y])
	{
		if (scent[x-1][y]>curmax)
		{
			curmax=scent[x-1][y];
			tarx=x-1;
			tary=y;
			dir=2;
		}
		if (perfume[x-1][y]>curmax)
		{
			curmax=perfume[x-1][y];
			tarx=x-1;
			tary=y;
			dir=2;
		}
	}
	if (x<(xtiles-1)  && !obstacles[x+1][y])
	{
		if (scent[x+1][y]>curmax)
		{
			curmax=scent[x+1][y];
			tarx=x+1;
			tary=y;
			dir=3;
		}		
		if (perfume[x+1][y]>curmax)
		{
			curmax=perfume[x+1][y];
			tarx=x+1;
			tary=y;
			dir=3;
		}	
	}
	if (y>0 && !obstacles[x][y-1])
	{
		if (scent[x][y-1]>curmax)
		{
			curmax=scent[x][y-1];
			tarx=x;
			tary=y-1;
			dir=0;
		}		
		if (perfume[x][y-1]>curmax)
		{
			curmax=perfume[x][y-1];
			tarx=x;
			tary=y-1;
			dir=0;
		}		
	}
	if (y<(ytiles-1) && !obstacles[x][y+1])
	{
		if (scent[x][y+1]>curmax)
		{
			curmax=scent[x][y+1];
			tarx=x;
			tary=y+1;
			dir=1;
		}
		if (perfume[x][y-1]>curmax)
		{
			curmax=perfume[x][y+1];
			tarx=x;
			tary=y-1;
			dir=1;
		}
	}
	
	if (x!=tarx || y!=tary)
	{
		obstacles[x][y]=false;
		x=tarx;
		y=tary;
		scent[x][y]=0;
		obstacles[x][y]=true;
	}
}


bool noenemyat(int x, int y)
{
	for (unsigned int i=0;i<enemies.size();i++)
	{
		if (enemies[i]->x==x && enemies[i]->y==y)
			return false;
	}
	if (canplayermove(x, y))
		return false;
	
	return true;
}

int wallindex(int x, int y)
{
	for (unsigned int i=0;i<walls.size();i++)
	{
		if (walls[i]->x==x && walls[i]->y==y)
		{
			return i;
		}
	}
	
	return -1;
}

void delenemyat(int x, int y)
{
	for (unsigned int i=0;i<enemies.size();i++)
	{
		if (enemies[i]->x==x && enemies[i]->y==y)
		{
			swap(enemies[i],enemies[enemies.size()-1]);
			enemies.resize(enemies.size()-1);
			kills++;
			empire++;
			if (empire>maxempire)
				maxempire=empire;
			break;
		}
	}			
}


void delwallat(int x, int y)
{
	for (unsigned int i=0;i<walls.size();i++)
	{
		if (walls[i]->x==x && walls[i]->y==y)
		{
			swap(walls[i],walls[walls.size()-1]);
			
			if (walls[i]->activearm[0])
			{
				tiles[walls[i]->x][walls[i]->y-1]=tile_grass;
			}
			if (walls[i]->activearm[1])
			{
				tiles[walls[i]->x][walls[i]->y+1]=tile_grass;
			}
			if (walls[i]->activearm[2])
			{
				tiles[walls[i]->x-1][walls[i]->y]=tile_grass;
			}
			if (walls[i]->activearm[3])
			{
				tiles[walls[i]->x+1][walls[i]->y]=tile_grass;
			}
			
	
			walls.resize(walls.size()-1);
			break;
		}
	}			
}


Entity* enemyat(int x, int y)
{
	for (unsigned int i=0;i<enemies.size();i++)
	{
		if (enemies[i]->x==x && enemies[i]->y==y)
			return enemies[i];
	}
	
	return 0;	
}

bool canenemymove(int x, int y)
{
	return (tiles[x][y]==tile_grass);
}

bool canplayermove(int x, int y)
{
	switch (tiles[x][y])
	{
		case tile_blood:
		case tile_blood1:
		case tile_blood2:
		case tile_blood3:
			return true;
		default:
			return false;
	}
}

const int tile_siren1=tilenum(0,4);
const int tile_siren2=tilenum(2,4);
const int tile_siren3=tilenum(1,3);
const int tile_siren4=tilenum(1,5);

bool siren(int x, int y)
{
	switch (tiles[x][y])
	{
		case tile_siren1:
		case tile_siren2:
		case tile_siren3:
		case tile_siren4:
			return true;
		default:
			return false;
	}
	return false;
}

void update_scent()
{
	for (int i=1;i<xtiles-1;i++)
		for (int j=1;j<ytiles-1;j++)
		{
			if (canenemymove(i,j))
				scent[i][j]=(scent[i-1][j]+scent[i+1][j]+scent[i][j-1]+scent[i][j+1])/4.0f;
			else if  (canplayermove(i,j))
				scent[i][j]=1.0f;
			else
				scent[i][j]=0.0f;
		}
}

void update_perfume()
{
	for (int i=1;i<xtiles-1;i++)
		for (int j=1;j<ytiles-1;j++)
		{
			if (canenemymove(i,j))
				perfume[i][j]=(perfume[i-1][j]+perfume[i+1][j]+perfume[i][j-1]+perfume[i][j+1])/4.0f;
			else if (siren(i,j))
				perfume[i][j]=4.0f;
			else
				perfume[i][j]=0;

		}
}


void place_initial_objects()
{
	flagdelete.clear();
	flagdelete2.clear();
	
	for (int i=0;i<xtiles;i++)
		for (int j=0;j<ytiles;j++)
		{
			tiles[i][j]=tile_grass;	
			obstacles[i][j]=false;
		}
	
	
	if (player!=0)
	{
		delete player;
		player=0;
	}
	player = new Player();
	player->x=5+rand()%(xtiles-10);
	player->y=5+rand()%(ytiles-10);
	player->dir=rand()%4;
	
	obstacles[player->x][player->y]=true;
	
	tiles[player->x][player->y]=tile_blood;
	
	for (int i=0;i<4+(rand()%40);i++)
	{
		int candx=2+rand()%(xtiles-4);
		int candy=2+rand()%(ytiles-4);
		if (abs(candx-player->x)>2 && abs(candx-player->y)>2)
		{
			tiles[candx][candy]=(rand()%2) ? tile_rock:tile_tree;
			obstacles[candx][candy]=true;
		}
	}
	
	for (unsigned int i=0;i<enemies.size();i++)
	{
		if (enemies[i]!=0)
		{
			delete enemies[i];
			enemies[i]=0;
		}
	}
	enemies.clear();
	
	for (unsigned int i=0;i<walls.size();i++)
	{
		if (walls[i]!=0)
		{
			delete walls[i];
			walls[i]=0;
		}
	}
	walls.clear();
	
	for (unsigned int i=0;i<15;i++)
	{
		int candx=2+rand()%(xtiles-4);
		int candy=2+rand()%(ytiles-4);
		if (noenemyat(candx,candy) && candx!=player->x && candy!=player->y)
		{
			Peasant* p=new Peasant;
			p->x=candx;
			p->y=candy;
			obstacles[candx][candy]=true;
			enemies.push_back(p);
		}
	}
}

int consequences=0;

void drawPreface()
{	
	clear_to_color(buffer, makecol(0,0,0));
}

bool escpressed;

class IntroLoop
{
public:
	static void initialize()
	{
		escpressed=true;
		speed_count=0;
		titletimer=0;
		finishedtitle=false;
		other_count=0;
	}	
	
	static bool quitcondition()
	{
		return quit||warover||finishedtitle;
	}
	
	static void logic()
	{
		titletimer++;
		
		if (titletimer>60||(mouse_b&1)||keypressed())
		{
			position_mouse(400,200);
			finishedtitle=true;
		}
	}
	
	static void draw()
	{
		clear_to_color(buffer,makecol(0,0,0));

		
		textout_ex(buffer, font, "increpare presents", 4, 50, makecol(100,100,100), makecol(0,0,0));

	}
};

int frame;
class StartingLoop
	{
	public:
		static void initialize()
		{
			escpressed=true;
			frame=0;
			clear_keybuf();
			finishedtitle=false;
		}	
		
		static bool quitcondition()
		{
			return finishedtitle;
		}
		
		static void logic()
		{
			titletimer++;
			
			if (titletimer>10&&keypressed())
			{
				if (frame>5||key[KEY_ESC])
					finishedtitle=true;
				else
					frame++;
			}
			clear_keybuf();
		}
		
		static void draw()
		{
			clear_to_color(buffer,makecol(0,0,0));
			
			switch(frame)
			{
				case 0:
					textout_ex(buffer, font, "i was so alone",2, 50, makecol(100,100,100), makecol(0,0,0));
					break;
				case 1:
					textout_ex(buffer, font, "in my death", 4, 50, makecol(100,100,100), makecol(0,0,0));
					break;
				case 2:
					textout_ex(buffer, font, "i dreamt of", 4, 50, makecol(100,100,100), makecol(0,0,0));
					textout_ex(buffer, font, "an empire", 44, 60, makecol(100,100,100), makecol(0,0,0));
					break;
				case 3:
					textout_ex(buffer, font, "of companions in", 4, 50, makecol(100,100,100), makecol(0,0,0));
					textout_ex(buffer, font, "blood", 44, 60, makecol(100,100,100), makecol(0,0,0));
					break;
				case 4:
					textout_ex(buffer, font, "skewered on steel", 4, 50, makecol(100,100,100), makecol(0,0,0));
					textout_ex(buffer, font, "prongs", 44, 60, makecol(100,100,100), makecol(0,0,0));
					
					break;
				case 5:
					textout_ex(buffer, font, "which i place on", 4, 50, makecol(100,100,100), makecol(0,0,0));
					textout_ex(buffer, font, "my borders", 44, 60, makecol(100,100,100), makecol(0,0,0));
					
					break;
				case 6:
					textout_ex(buffer, font, "should my empire", 4, 50, makecol(100,100,100), makecol(0,0,0));
					textout_ex(buffer, font, "diminish in size", 24, 60, makecol(100,100,100), makecol(0,0,0));
					textout_ex(buffer, font, "by 10 carcasses", 24, 70, makecol(100,100,100), makecol(0,0,0));
					textout_ex(buffer, font, "all will be lost", 24, 80, makecol(100,100,100), makecol(0,0,0));
					break;
		}
		}
	};

class GameOverLoop
	{
	public:
		static void initialize()
		{
			std::cout<<"GAMEOVER";
			escpressed=true;
			warover=false;
			speed_count=0;
			titletimer=0;
			finishedtitle=false;
			other_count=0;
			clear_keybuf();
		}	
		
		static bool quitcondition()
		{
			return quit||warover||finishedtitle;
		}
		
		static void logic()
		{
			titletimer++;
			
			if (titletimer>30&&keypressed())
			{
				finishedtitle=true;
			}
			clear_keybuf();
		}
		
		static void draw()
		{
			clear_to_color(buffer,makecol(0,0,0));
			
			
			textout_ex(buffer, font, "game over", 4, 10, makecol(100,100,100), makecol(0,0,0));
			
			textout_ex(buffer,font,"Score",
					   30,24,makecol(255,255,255),-1);
			textout_ex(buffer,font,boost::lexical_cast<std::string>(kills).c_str(),30+9*5,24,makecol(255,255,255),-1);
			textout_ex(buffer,font,"Size",
					   30,34,makecol(255,255,255),-1);
			textout_ex(buffer,font,boost::lexical_cast<std::string>(empire).c_str(),30+9*5,34,makecol(255,255,255),-1);
			textout_ex(buffer,font,"Max",
					   30,44,makecol(255,255,255),-1);
			textout_ex(buffer,font,boost::lexical_cast<std::string>(maxempire).c_str(),30+9*5,44,makecol(255,255,255),-1);
			textout_ex(buffer,font,"Reason",
					   4,54,makecol(255,255,255),-1);
			if (deathbymurder)
			{
				textout_ex(buffer,font,"murdered by soldier",10,64,makecol(255,255,255),-1);			
			}
			else
			{
				textout_ex(buffer,font,"empire decreased",10,64,makecol(255,255,255),-1);
				textout_ex(buffer,font,"10 bodies from",10,74,makecol(255,255,255),-1);
				textout_ex(buffer,font,"max",10,84,makecol(255,255,255),-1);
			}
			
			
		}
	};

class TitleLoop
{
private:
	static bool begin;
	static unsigned int selected;
	static bool upheld;
	static bool downheld;
	static bool spaceheld;
public:
	static void initialize()
	{
		begin=false;
		selected=0;
		upheld=true;
		downheld=true;
		spaceheld=true;
		escpressed=true;	
	}
	
	static void logic()
	{
		if (key[KEY_ESC]&&!escpressed)
			quit=true;
		escpressed=key[KEY_ESC];

		if (key[KEY_UP])
		{
			if (!upheld)
			{
				selected=(selected+1)%2;			
				upheld=true;
			}
		}
		else
			upheld=false;
		
		if (key[KEY_DOWN])
		{
			if (!downheld)
			{
				selected=(selected+1)%2;			
				downheld=true;
			}
		}
		else
			downheld=false;
		
		if (key[KEY_SPACE])
		{
			if (!spaceheld)
			{
				if (selected==0)
				{
					begin=true;
				}
				else
				{
					quit=true;
				}
			}
		}
		else
			spaceheld=false;
		
	}
	
	static bool quitcondition()
	{
		return quit||begin;
	}
		
	static void draw()
	{
		clear_to_color(buffer,makecol(255,0,0));
		textout_ex(buffer,font,"My Empire The Wall",8,45,makecol(240,126,114),makecol(0,0,0));
		if (selected==0)
		{
			textout_ex(buffer,font,"Start",59,60,makecol(100,100,100),makecol(255,255,255));
			textout_ex(buffer,font,"Exit",59,82,makecol(255,255,255),makecol(0,0,0));
		}
		else
		{
			textout_ex(buffer,font,"Start",59,60,makecol(255,255,255),makecol(0,0,0));
			textout_ex(buffer,font,"Exit",59,82,makecol(100,100,100),makecol(255,255,255));
		}			

	}

};

bool TitleLoop::begin=false;
unsigned int TitleLoop::selected=0;
bool TitleLoop::upheld=false;
bool TitleLoop::downheld=false;
bool TitleLoop::spaceheld=true;

bool pressed[5];
unsigned int curselected;
enum GameState {
	gs_selecting,
	gs_weather,
	gs_action
} gamestate;

string displaystring;
int turn;
const int maxturn=8;

void drawtile(int destx,int desty, int tilen)
{
	blit(tilemap, buffer, (tilen%tilemapwidth)*tilesize, (tilen/tilemapwidth)*tilesize, destx*tilesize+xmarginl, desty*tilesize+ymargint, tilesize, tilesize);
}

void mdrawtile(int destx,int desty, int tilen)
{
	masked_blit(tilemap, buffer, (tilen%tilemapwidth)*tilesize, (tilen/tilemapwidth)*tilesize, destx*tilesize+xmarginl, desty*tilesize+ymargint, tilesize, tilesize);
}

class GameLoop
{
public:
	static void initialize()
	{
		deathbymurder=false;
		dead=false;
		kills=0;
		srand(time(0));
		for (int i=0;i<xtiles;i++)
			for (int j=0;j<ytiles;j++)
			{
				tiles[i][j]=0;
			}
		
		empire=1;
		maxempire=1;
		place_initial_objects();
		
		placefork();
		
		consequences=false;
		warover=false;
		leave=false;

		escpressed=true;
		
		
		for (int i=0;i<5;i++)
			pressed[i]=true;
		curselected=0;
		gamestate=gs_selecting;
		displaystring="";
	
		turn=0;
		
	}	
	
	static bool quitcondition()
	{
		return quit||leave||warover||dead;
	}
	
	static void gametick()
	{
		for (unsigned int i=0;i<walls.size();i++)
		{
			walls[i]->process();
		}
		
		for (unsigned int i=0;i<flagdelete.size();i++)
		{
			delwallat(flagdelete[i].first,flagdelete[i].second);
		}
		flagdelete.clear();
	
		
		for (unsigned int i=0;i<enemies.size();i++)
		{
			enemies[i]->move();
		}
		
		for (unsigned int i=0;i<flagdelete2.size();i++)
		{
			if (player->x==flagdelete2[i].first&&player->y==flagdelete2[i].second)
			{
				dead=true;
				deathbymurder=true;
			}
			delwallat(flagdelete2[i].first,flagdelete2[i].second);
			tiles[flagdelete2[i].first][flagdelete2[i].second]=tile_grass;
			if (obstacles[flagdelete2[i].first][flagdelete2[i].second])
			{
				empire--;
				if (empire+10<maxempire)
				{
					dead=true;
				}
			}
			obstacles[flagdelete2[i].first][flagdelete2[i].second]=false;
			
		}
		flagdelete2.clear();			
		
	}
	
	static void placefork()
	{
		if (internalwall(player->x,player->y))
			return;
		int i=wallindex(player->x,player->y);
		if (i>=0)
		{
			if (walls[i]->walltype!=1)
			{
				delete walls[i];
				walls[i]=new Fork;
				walls[i]->x=player->x;
				walls[i]->y=player->y;
			}
		}
		else
		{
			Fork* f=new Fork;
			f->x=player->x;
			f->y=player->y;
			f->walltype=1;
			walls.push_back(f);
		}	
	}
	
	
	static void logic()
	{
		
		if (other_count%7==0)
		{
			update_perfume();
		}
		else if (other_count%5==0)
		{
			update_scent();
		}
		
	
		if (other_count>30)
		{
			other_count=0;
			gametick();
		}
		
		
		if (enemies.size()<10+kills/4)
		{
			int candx=2+rand()%(xtiles-4);
			int candy=2+rand()%(ytiles-4);
			if (noenemyat(candx,candy) && candx!=player->x && candy!=player->y)
			{
				Entity* p;
				if (rand()%2==0 || (kills>100 &&  kills<200 &&rand()%3>0) || (kills>200 && kills< 300 && rand()%5>0) || (kills>300))
					p=new Swordsman;
				else
					p=new Peasant;
				p->x=candx;
				p->y=candy;
				obstacles[candx][candy]=true;
				enemies.push_back(p);
			}
		}
		
		
		if (key[KEY_UP]&&!pressed[0]&&gamestate==gs_selecting)
		{
			player->dir=0;
			if (canplayermove(player->x, player->y-1))
				{
				player->y--;
					placefork();
				}
		}
		else if (key[KEY_DOWN]&&!pressed[1]&&gamestate==gs_selecting)
		{
			player->dir=1;
			if (canplayermove(player->x, player->y+1))
			{
				player->y++;
				placefork();
			}
		}
		else if (key[KEY_LEFT]&&!pressed[2]&&gamestate==gs_selecting)
		{
			player->dir=2;
			if (canplayermove(player->x-1, player->y))
			{
				player->x--;
				placefork();
			}
		}
		else if (key[KEY_RIGHT]&&!pressed[3]&&gamestate==gs_selecting)
		{
			player->dir=3;
			if (canplayermove(player->x+1, player->y))
			{
				player->x++;
				placefork();
			}
		}
		
		if (key[KEY_1]&&(!internalwall(player->x,player->y)))
		{
		
		}
		

		if (key[KEY_SPACE]&&!pressed[4]&&gamestate==gs_selecting)
		{
		
			
		}
		
				
		if (key[KEY_ESC]&&!escpressed)
			leave=true;
		escpressed=key[KEY_ESC];
		
		pressed[0]=key[KEY_UP];
		pressed[1]=key[KEY_DOWN];
		pressed[2]=key[KEY_LEFT];
		pressed[3]=key[KEY_RIGHT];
		pressed[4]=key[KEY_SPACE];
		
	}
	
	static void draw()
	{
		clear_to_color(buffer,makecol(0,0,0));

		for (int i=0;i<xtiles;i++)
			for (int j=0;j<ytiles;j++)
			{
				drawtile(i, j, tiles[i][j]);
			}
		for (unsigned int i=0;i<enemies.size();i++)
		{
			drawtile(enemies[i]->x,enemies[i]->y,enemies[i]->basetile+enemies[i]->dir);
		}
		for (unsigned int i=0;i<walls.size();i++)
		{
			walls[i]->draw();
		}
		
		player->draw();
		
		textout_ex(buffer,font,"Score",
				4,4,makecol(255,255,255),-1);
		textout_ex(buffer,font,boost::lexical_cast<std::string>(kills).c_str(),4+6*8,4,makecol(255,255,255),-1);
		textout_ex(buffer,font,"Size",
				   4,14,makecol(255,255,255),-1);
		textout_ex(buffer,font,boost::lexical_cast<std::string>(maxempire).c_str(),4+6*8,14,makecol(255,255,255),-1);
		textout_ex(buffer,font,"Max",
				   4,24,makecol(255,255,255),-1);
		textout_ex(buffer,font,boost::lexical_cast<std::string>(empire).c_str(),4+6*8,24,makecol(255,255,255),-1);
	}
	
};

template<class T>
void loop()
{
	
	T::initialize();
	
	while(!T::quitcondition())
	{
		al_poll_duh(dplay);
		
		while(speed_count>0)
		{
			poll_mouse();
			
//			if (key[KEY_ESC])
//				quit=true;
			
			T::logic();
			
			speed_count--;
			
		}
		
		T::draw();
		
		stretch_blit(buffer,screen,0,0,160,120,0,0,640,480);
	}
}




void init()
{
	
	/* initialise everything */
	allegro_init();
	init_sound();
	
	set_color_depth(32);
	
	install_keyboard();
	install_mouse();
	install_timer();
	
	CGDisplayHideCursor(kCGDirectMainDisplay);
	
	set_alpha_blender();
	
    LOCK_VARIABLE(speed_counter); //Used to set the timer - which regulates the game's
    LOCK_FUNCTION(increment_speed_counter);//speed.
    install_int_ex(increment_speed_counter, BPS_TO_TIMER(30));	
	
	set_gfx_mode(GFX_AUTODETECT_FULLSCREEN, 640, 480, 0, 0) ;
	
	//init the buffer
	buffer=create_bitmap(160,120);
	tilemap=load_bitmap("bmp/tilemap.bmp",NULL);
	if (tilemap==0)
	{
		std::cout<<"BORKED";
	}
	
}

int dir;
int px;
int py;

int main(int argc, char *argv[])
{
	
	init();
	

	loop<IntroLoop>();
	
	playmusic(1);	
	
	title:
	loop<TitleLoop>();

	while (!quit)
	{
		loop<StartingLoop>();
		loop<GameLoop>();	
		if (leave)
		{
			goto title;
		}
		
		loop<GameOverLoop>();
		goto title;
	}
	
	return 0;
}
END_OF_MAIN()